<?php

include($_SERVER['DOCUMENT_ROOT'] . '/bitrix/modules/main/include/prolog_before.php');

if (!defined('SITE_ID')) {
    echo 'На сайте отсутсвует папка bitrix. Переместите файл на сайт с 1С-Битрикс.';
    return;
}

\Bitrix\Main\UI\Extension::load("ui.bootstrap4");

class Fixit
{
    const MAX_STEP = 100;
    const MAX_STEP_TIME = 1;
    const DIR_PERMISSIONS = 0755;
    const UPLOAD_ZIP_DIR = 'sotbit_fix_files';

    protected $sd;
    protected $zip;
    protected $siteId;
    protected $siteRoot;

    public function __construct()
    {
        $this->startSession();
        $this->fillData();
        $this->siteId = $_REQUEST['site_id'] ?? SITE_ID;
        $this->siteRoot = \Bitrix\Main\SiteTable::getDocumentRoot($this->siteId);
    }

    protected function startSession()
    {
        if (array_key_exists('session_id', $_REQUEST) && $_REQUEST['session_id']) {
            session_id($_REQUEST['session_id']);
        } else {
            $bCLear = true;
        }

        session_start();

        if ($bCLear) {
            unset($_SESSION['Fixit']);
        }
    }

    protected function fillData()
    {
        ob_start();

        if (
            !isset($_SESSION['Fixit'])
            || !is_array($_SESSION['Fixit'])
            || !isset($_SESSION['Fixit']['error'])
            || !is_string($_SESSION['Fixit']['error'])
            || !isset($_SESSION['Fixit']['options'])
            || !is_array($_SESSION['Fixit']['options'])
            || !isset($_SESSION['Fixit']['cnt_checked_files'])
            || !is_int($_SESSION['Fixit']['cnt_checked_files'])
            || !isset($_SESSION['Fixit']['finded_files'])
            || !is_array($_SESSION['Fixit']['finded_files'])
            || !isset($_SESSION['Fixit']['fixed_files'])
            || !is_array($_SESSION['Fixit']['fixed_files'])
            || !isset($_SESSION['Fixit']['stages'])
            || !is_array($_SESSION['Fixit']['stages'])
        ) {
            $_SESSION['Fixit'] = [
                'error' => '',
                'options' => [],
                'cnt_checked_files' => 0,
                'finded_files' => [],
                'fixed_files' => [],
                'stages' => [
                    'finish' => [],
                ],
            ];
        }

        $this->sd = &$_SESSION['Fixit'];
    }

    public function getStep()
    {
        $step = intval($_REQUEST['step'] ?? 0);
        return max($step, 0);
    }

    public function nextStep($bForce = false)
    {
        $nextStep = $this->getStep() + 1;
        $action = $this->getAction();

        $url = '?session_id=' . session_id() . '&action=' . htmlspecialchars($action) . '&site_id=' . $this->siteId . '&step=' . intval($nextStep);

        if ($bForce) {
            header('Location: ' . $url);
            exit;
        } else {
            ?>
            <script>
                setTimeout(function () {
                    location.href = <?php var_export($url); ?>;
                }, 0);
            </script>
            <?php
        }
    }

    public function getOptions()
    {
        $options = [
            'create_back' => 1,
            'create_zip' => 1,
            'self_deletion' => 0,
            'full_scan' => 0,
            'files' => [],
        ];

        if (
            isset($this->sd['options'])
            && is_array($this->sd['options'])
        ) {
            $options = array_merge($options, $this->sd['options']);
        }

        if (isset($_REQUEST['options']['create_back'])) {
            $options['create_back'] = boolval($_REQUEST['options']['create_back']);
        }

        if (isset($_REQUEST['options']['create_zip'])) {
            $options['create_zip'] = boolval($_REQUEST['options']['create_zip']);
        }

        if (isset($_REQUEST['options']['self_deletion'])) {
            $options['self_deletion'] = boolval($_REQUEST['options']['self_deletion']);
        }

        if (isset($_REQUEST['options']['full_scan'])) {
            $options['full_scan'] = boolval($_REQUEST['options']['full_scan']);
        }

        if (isset($_REQUEST['options']['files']) && is_array($_REQUEST['options']['files'])) {
            $options['files'] = $_REQUEST['options']['files'];
        }

        $options['create_zip'] = $this->canZip();

        return $options;
    }

    public function canZip()
    {
        return class_exists('ZipArchive');
    }

    public function isWindows()
    {
        static $result;

        if (!isset($result)) {
            $result = 'WIN' === strtoupper(substr(PHP_OS, 0, 3));
        }

        return $result;
    }

    public function execute()
    {
        try {
            $method = $this->getActionMethod();
            $this->$method();
        } catch (Exception $e) {
            $this->setError($e->getMessage());
        }

        $this->closeZip();
    }

    public function getActionMethod()
    {
        $action = $this->getAction();
        $method = $action . 'Action';
        if (!method_exists($this, $method)) {
            $method = 'mainAction';
        }

        return $method;
    }

    public function getAction()
    {
        $action = htmlspecialchars(trim(isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));
        $action = strlen($action) ? $action : 'main';

        return $action;
    }

    public function mainAction()
    {
    }

    public function isMainAction()
    {
        return 'mainAction' === $this->getActionMethod();
    }

    public function previewAction()
    {
        $options = $this->getOptions();
        $options['files'] = [];

        $step = $this->getStep();
        if ($step > static::MAX_STEP) {
            throw new Exception('Превышено максимальное число шагов (' . static::MAX_STEP . ').<br />Проверьте отсутствие зацикленности в структуре папок.');
        }

        if (!$step) {
            if ($options['full_scan']) {
                $remainingDirs = [
                    $this->siteRoot
                ];
                $arExcludeSubDirs = [
                    $this->siteRoot . '/bitrix/cache',
                    $this->siteRoot . '/bitrix/managed_cache',
                    $this->siteRoot . '/bitrix/stack_cache',
                    $this->siteRoot . '/bitrix/updates',
                    $this->siteRoot . '/bitrix/panel',
                    $this->siteRoot . '/bitrix/components/bitrix',
                    $this->siteRoot . '/bitrix/wizards/bitrix',
                    $this->siteRoot . '/bitrix/gadgest/bitrix',
                    $this->siteRoot . '/bitrix/blocks/bitrix',
                    $this->siteRoot . '/local/components/bitrix',
                    $this->siteRoot . '/local/wizards/bitrix',
                    $this->siteRoot . '/local/gadgest/bitrix',
                    $this->siteRoot . '/local/blocks/bitrix',
                    __DIR__,
                ];
            } else {
                $remainingDirs = [
                    $this->siteRoot,
                    $this->siteRoot . '/bitrix/components/sotbit*',
                    $this->siteRoot . '/bitrix/modules/sotbit*',
                    $this->siteRoot . '/bitrix/tools/sotbit*',
                    $this->siteRoot . '/bitrix/gadgets/sotbit*',
                    $this->siteRoot . '/bitrix/wizards/sotbit*',
                    $this->siteRoot . '/bitrix/blocks/sotbit*',
                    $this->siteRoot . '/bitrix/templates',
                    $this->siteRoot . '/local/components/sotbit*',
                    $this->siteRoot . '/local/modules/sotbit*',
                    $this->siteRoot . '/local/tools/sotbit*',
                    $this->siteRoot . '/local/gadgets/sotbit*',
                    $this->siteRoot . '/local/wizards/sotbit*',
                    $this->siteRoot . '/local/blocks/sotbit*',
                    $this->siteRoot . '/local/templates',
                ];
                $arExcludeSubDirs = [
                    $this->siteRoot . '/bitrix',
                    $this->siteRoot . '/bitrix/cache',
                    $this->siteRoot . '/bitrix/managed_cache',
                    $this->siteRoot . '/bitrix/stack_cache',
                    $this->siteRoot . '/bitrix/updates',
                    $this->siteRoot . '/bitrix/panel',
                    $this->siteRoot . '/bitrix/components',
                    $this->siteRoot . '/bitrix/modules',
                    $this->siteRoot . '/bitrix/tools',
                    $this->siteRoot . '/bitrix/gadgets',
                    $this->siteRoot . '/bitrix/wizards',
                    $this->siteRoot . '/bitrix/blocks',
                    $this->siteRoot . '/local/components',
                    $this->siteRoot . '/local/modules',
                    $this->siteRoot . '/local/tools',
                    $this->siteRoot . '/local/gadgets',
                    $this->siteRoot . '/local/wizards',
                    $this->siteRoot . '/local/blocks',
                    $this->siteRoot . '/upload',
                    $this->siteRoot . '/.git',
                    $this->siteRoot . '/.idea',
                    $this->siteRoot . '/.vscode',
                    __DIR__,
                ];
            }

            $arExcludeSubDirs = array_merge($arExcludeSubDirs, [
                $this->siteRoot . '/bitrix/modules/sotbit.b2c/lib/solution-setup',
                $this->siteRoot . '/bitrix/modules/sotbit.b2b/lib/solution-setup',
                $this->siteRoot . '/bitrix/modules/sotbit.speedpage',
            ]);

            $this->sd = [
                'error' => '',
                'options' => $options,
                'cnt_checked_files' => 0,
                'finded_files' => [],
                'fixed_files' => [],
                'zip_path' => '',
                'remaining_dirs' => $remainingDirs,
                'exclude_subdirs' => $arExcludeSubDirs,
                'remaining_files' => [],
                'unlink_files' => [],
                'patch_files' => [],
                'stages' => [
                    'unserialize' => [],
                    'finish' => [],
                ],
            ];
        } else {
            $stage = $this->getStage();
            $maxtime = time() + static::MAX_STEP_TIME;

            while (
                time() <= $maxtime
                && !$this->isFinishStage()
            ) {
                if ('unserialize' === $stage) {
                    $arExcludeSubDirNames = ['.', '..'];

                    if (empty($this->sd['remaining_dirs'])) {
                        $this->nextStage();
                    } else {
                        $dir = array_shift($this->sd['remaining_dirs']);
                        if ($dir) {
                            $dir = rtrim($dir, '/');

                            if ($this->sd['unlink_files']) {
                                foreach ($this->sd['unlink_files'] as $unlinkFile) {
                                    $unilnkFile = $dir . $unlinkFile;
                                    if (@file_exists($dir . $unlinkFile)) {
                                        $this->sd['finded_files'][$unilnkFile] = 'D';
                                    }
                                }
                            }

                            $phpFiles = array_merge(
                                (array)glob($dir . '/*.php', GLOB_NOSORT),
                                (array)glob($dir . '/.*.php', GLOB_NOSORT),
                                (array)glob($dir . '/,*.php', GLOB_NOSORT)
                            );

                            $subDirs = array_merge(
                                (array)glob($dir . '/*', GLOB_ONLYDIR),
                                (array)glob($dir . '/.*', GLOB_ONLYDIR),
                                (array)glob($dir . '/,*', GLOB_ONLYDIR)
                            );

                            if ($subDirs) {
                                foreach ($subDirs as $i => $subDir) {
                                    $subDirName = basename($subDir);

                                    if (
                                        in_array($subDirName, $arExcludeSubDirNames)
                                        || in_array($subDir, $this->sd['exclude_subdirs'])
                                    ) {
                                        unset($subDirs[$i]);
                                        continue;
                                    }

                                    if (preg_match('/\/vendors?\//mis', $subDir, $tmp)) {
                                        unset($subDirs[$i]);
                                        continue;
                                    }

                                    if (
                                        $options['full_scan']
                                        && preg_match('/(bitrix|local)\/modules\/([^\/]+)$/mis', $subDir, $tmp)
                                        && false === strpos($tmp[2], '.')
                                    ) {
                                        unset($subDirs[$i]);
                                    }
                                }

                                if ($subDirs) {
                                    $this->sd['remaining_dirs'] = array_merge($subDirs, $this->sd['remaining_dirs']);
                                }
                            }

                            if ($phpFiles) {
                                foreach ($phpFiles as $phpFile) {
                                    ++$this->sd['cnt_checked_files'];

                                    $content = $this->getModifiedContent($phpFile);
                                    if (false !== $content) {
                                        $this->sd['finded_files'][$phpFile] = 'M';
                                    }
                                }
                            }
                        }
                    }
                }

                $stage = $this->getStage();
            }
        }
    }

    public function isPreviewAction()
    {
        return 'previewAction' === $this->getActionMethod();
    }

    public function fixAction()
    {
        $options = $this->getOptions();

        $step = $this->getStep();
        if ($step > static::MAX_STEP) {
            throw new Exception('Превышено максимальное число шагов (' . static::MAX_STEP . ').<br />Проверьте отсутствие зацикленности в структуре папок.');
        }

        if (!$step) {
            $remainingFiles = $options['files'];
            $zipPath = \Bitrix\Main\IO\Path::combine(
                $this->siteRoot,
                \Bitrix\Main\Config\Option::get('main', 'upload_dir', 'upload'),
                static::UPLOAD_ZIP_DIR,
                $this->generateZipName()
            );

            $this->sd = [
                'error' => '',
                'options' => $options,
                'cnt_checked_files' => $this->sd['cnt_checked_files'],
                'finded_files' => $this->sd['finded_files'],
                'fixed_files' => [],
                'zip_path' => $zipPath,
                'remaining_files' => $remainingFiles,
                'unlink_files' => [],
                'patch_files' => [],
                'stages' => [
                    'unserialize' => [],
                    'finish' => [],
                ],
            ];

            if ($options['create_zip']) {
                $this->openZip();
            }
        } else {
            $stage = $this->getStage();
            $maxtime = time() + static::MAX_STEP_TIME;

            if ($options['create_zip']) {
                $this->openZip();
            }

            while (
                time() <= $maxtime
                && !$this->isFinishStage()
            ) {
                if ('unserialize' === $stage) {
                    if (empty($this->sd['remaining_files'])) {
                        $this->nextStage();
                    } else {
                        $file = array_shift($this->sd['remaining_files']);
                        if ($file) {
                            $file = trim($file);
                            if (
                                strlen($file)
                                && isset($this->sd['finded_files'][$file])
                            ) {
                                if ('D' === $this->sd['finded_files'][$file]) {

                                    if ($options['create_zip']) {
                                        $this->add2Zip(dirname($file));
                                        $this->add2Zip($file);
                                    }

                                    @unlink($file);
                                    $this->sd['fixed_files'][$file] = 'D';
                                } elseif ('M' === $this->sd['finded_files'][$file]) {
                                    $content = $this->getModifiedContent($file);
                                    if (false !== $content) {
                                        if ($options['create_back']) {
                                            $backFile = $this->createBack($file);
                                        }

                                        if ($options['create_zip']) {
                                            $this->add2Zip(dirname($file));
                                            $this->add2Zip($file);
                                        }

                                        @file_put_contents($file, $content);
                                        $this->sd['fixed_files'][$file] = 'M';
                                    }
                                }
                            }
                        }
                    }
                }

                $stage = $this->getStage();
            }
        }
    }

    public function getModifiedContent($file)
    {
        $file = trim($file);
        if (!$file) {
            return false;
        }

        $content = @file_get_contents($file);
        if ($content === false || empty($content)) {
            return false;
        }

        $bModified = false;
        $safe = [];

        if ($this->sd['patch_files']) {
            foreach ($this->sd['patch_files'] as $patchFile => $replace) {
                if (
                    false !== strpos($file, $patchFile)
                    && $replace
                    && is_array($replace)
                ) {
                    foreach ($replace[0] as $r) {
                        if (false !== strpos($content, $r)) {
                            $content = str_replace($replace[0], $replace[1], $content);
                            $bModified = true;
                            break;
                        }
                    }
                    break;
                }
            }
        }

        if (strpos($content, 'unserialize') !== false) {
            $basePattern = '(?<!->|->\s|::|::\s|\'|"|{|function\s|function\s\s|[$_a-z0-9])unserialize\s*[\(].*?[\)]';

            $pattern = $basePattern;

            while (preg_match('/' . $pattern . '/msi', $content, $match)) {
                $expression = $match[0];

                if ($this->testCorrectFuncExpression($expression)) {
                    if (
                        strpos($expression, 'allowed_classes') === false
                        && !preg_match('/unserialize\s*[\(].*?[,]\s*[\$][^\)]*?[\)]/msi', $expression, $tmp)
                    ) {
                        $newmatch = preg_replace('/(.*?)[\)]$/', '$1, [\'allowed_classes\' => false])', $expression);
                        $content = preg_replace('/' . $pattern . '/msi', $newmatch, $content, 1);
                        $bModified = true;
                    } else {
                        $safeKey = '##_SAFE_' . count($safe) . '##';
                        $safe[$safeKey] = $expression;
                        $content = preg_replace('/' . $pattern . '/msi', $safeKey, $content, 1);
                    }

                    $pattern = $basePattern;
                } else {
                    $pattern .= '.*?[\)]';
                }
            }

            if ($safe) {
                $content = str_replace(array_keys($safe), array_values($safe), $content);
            }
        }

        return $bModified ? $content : false;
    }

    public function isFixAction()
    {
        return 'fixAction' === $this->getActionMethod();
    }

    public function getFindedFiles()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['finded_files'])
            && is_array($this->sd['finded_files'])
        ) {
            return $this->sd['finded_files'];
        }

        return [];
    }

    public function getFixedFiles()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['fixed_files'])
            && is_array($this->sd['fixed_files'])
        ) {
            return $this->sd['fixed_files'];
        }

        return [];
    }

    public function getCntCheckedFiles()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['cnt_checked_files'])
        ) {
            return intval($this->sd['cnt_checked_files']);
        }

        return 0;
    }

    public function getError()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['error'])
            && is_string($this->sd['error'])
        ) {
            return $this->sd['error'];
        }

        return '';
    }

    public function hasError()
    {
        return strlen($this->getError()) > 0;
    }

    public function setError($message)
    {
        if (
            $this->sd
            && is_array($this->sd)
        ) {
            $this->sd['error'] = $message;
            $this->sd['stages'] = [
                'finish' => [],
            ];
        }
    }

    public function getStage()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['stages'])
            && is_array($this->sd['stages'])
        ) {
            return key($this->sd['stages']);
        }

        return '';
    }

    public function nextStage()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['stages'])
            && is_array($this->sd['stages'])
        ) {
            array_shift($this->sd['stages']);
        }
    }

    public function isFinishStage()
    {
        $stage = $this->getStage();

        return !$stage || 'finish' === $stage;
    }

    protected function testCorrectFuncExpression($expression)
    {
        if ($expression) {
            return preg_match_all('/[\(]/', $expression) == preg_match_all('/[\)]/', $expression);
        }

        return false;
    }

    protected function createBack($filePath)
    {
        if (
            $filePath
            && @file_exists($filePath)
            && !@is_dir($filePath)
        ) {
            $basename = basename($filePath);
            $dirname = dirname($filePath);
            $backFile = $dirname . '/_' . $basename . '.back';

            @unlink($backFile);
            @copy($filePath, $backFile);

            return $backFile;
        }

        return '';
    }

    public function getZipPath()
    {
        if (
            $this->sd
            && is_array($this->sd)
            && isset($this->sd['zip_path'])
            && is_string($this->sd['zip_path'])
        ) {
            return $this->sd['zip_path'];
        }

        return '';
    }

    protected function openZip()
    {
        $zipPath = $this->sd['zip_path'];

        @mkdir(dirname($zipPath), static::DIR_PERMISSIONS, true);
        $this->zip = new ZipArchive();
        if (true !== $this->zip->open($zipPath, ZipArchive::CREATE)) {
            $this->sd['options']['create_zip'] = false;
            $this->sd['zip_path'] = '';
            $this->zip = null;
        }
    }

    protected function generateZipName()
    {
        return \Bitrix\Main\Security\Random::getString(5) . "_" . $this->siteId . '_' . date('d_m_Y') . '.zip';
    }

    protected function add2Zip($filePath)
    {
        if ($this->zip) {
            if (@file_exists($filePath)) {
                $basename = basename($filePath);
                $dirname = str_replace($this->siteRoot, '', dirname($filePath));
                $fileInZip = (strlen($dirname) ? str_replace('!#_#/', '', '!#_#' . $dirname) . '/' : '') . $basename;

                if (@is_dir($filePath)) {
                    $this->zip->addEmptyDir($this->encodeToZip($fileInZip));
                } else {
                    $handle = @fopen($filePath, 'rb');
                    if ($handle) {
                        $contents = @fread($handle, @filesize($filePath));
                        if (false !== $contents) {
                            $this->zip->addFromString($this->encodeToZip($fileInZip), $contents);
                        }

                        @fclose($handle);
                    }
                }
            }
        }
    }

    protected function closeZip()
    {
        if ($this->zip && is_object($this->zip)) {
            if ('ZipArchive' === get_class($this->zip)) {
                $this->zip->close();
            }

            unset($this->zip);
            $this->zip = null;
        }
    }

    protected function encodeToZip($str)
    {
        return iconv($this->isWindows() ? 'cp1251' : 'utf-8', 'CP866//IGNORE', $str);
    }

    public function cleanAction()
    {
        @unlink(__FILE__);
    }

    public static function getSiteList()
    {
        $result = \Bitrix\Main\SiteTable::query()
            ->setSelect(['LID', 'NAME'])
            ->addOrder('SORT')
            ->fetchAll();

        return array_combine(
            array_column($result, 'LID'),
            array_map(function ($item) {
                return "[{$item['LID']}] {$item['NAME']}";
            }, $result)
        );
    }

    public function getSite()
    {
        return $this->siteId;
    }

    public function getSiteRoot()
    {
        return $this->siteRoot;
    }
}

$fixit = new Fixit();
$fixit->execute();
$options = $fixit->getOptions();
$cntCheckedFiles = $fixit->getCntCheckedFiles();
$findedFiles = $fixit->getFindedFiles();
$fixedFiles = $fixit->getFixedFiles();
$siteId = $fixit->getSite();

if ($fixit->isFixAction()) {
    if (
        $options['self_deletion']
        && $fixit->isFinishStage()
    ) {
        $fixit->cleanAction();
    }
}


$disabledForm = $fixit->isFinishStage() || $fixit->hasError();
?>

<!DOCTYPE html>
<html xml:lang="ru" lang="ru" data-bs-theme="dark">
<head>
    <meta name="robots" content="noindex, nofollow"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="user-scalable=no, initial-scale=1.0, maximum-scale=1.0, width=device-width">
    <title>Поиск уязвимостей</title>
    <link rel="stylesheet" href="/bitrix/js/ui/bootstrap4/css/bootstrap.css">
    <style>
        .form-check-input,
        .form-check-label {
            cursor: pointer;
        }
    </style>
</head>
<body>
<div class="container-fluid">
    <div class="page-header">
        <h1>Поиск уязвимостей</h1>
    </div>

    <div class="page-content">
        <form action="" method="POST">
            <?php
            if ($fixit->hasError()) { ?>
                <div class="alert alert-danger mb-3" role="alert">
                    <?php
                    echo $fixit->getError(); ?>
                </div>
                <?php
            } ?>

            <?php
            if (file_exists(__FILE__)) { ?>
                <?php
                if (!$fixit->isMainAction() || !$fixit->hasError()) { ?>
                    <div class="card">
                        <div class="card-body">
                            <input type="hidden" name="session_id" value="<?php
                            echo session_id(); ?>"/>
                            <input type="hidden" name="step" value="0"/>

                            <div class="mb-3">
                                <label for="site_id" class="form-label">Сайт</label>
                                <select id="site_id" class="form-select"
                                        name="site_id" <?= $disabledForm ? '' : ' disabled'; ?>>
                                    <?php
                                    foreach (Fixit::getSiteList() as $lid => $site): ?>
                                        <option value="<?= $lid ?>" <?= $lid === $siteId ? 'selected' : '' ?>><?= $site ?></option>
                                    <?php
                                    endforeach; ?>
                                </select>
                            </div>

                            <div class="mb-3">
                                <label for="options--full_scan" class="form-label">Область поиска</label>
                                <select id="options--full_scan" class="form-select"
                                        name="options[full_scan]" <?= $disabledForm ? '' : ' disabled'; ?>>
                                    <option value="0" <?= !$options['full_scan'] ? 'selected' : '' ?>>Файлы решений
                                        Сотбит
                                    </option>
                                    <option value="1" <?= $options['full_scan'] ? 'selected' : '' ?>>Файлы всех
                                        решений
                                    </option>
                                </select>
                            </div>

                            <button type="submit" class="btn btn-primary me-md-2" name="action"
                                    value="preview" <?= $disabledForm ? '' : ' disabled'; ?> >Сканировать
                            </button>
                            <button type="submit" class="btn btn-danger" name="action"
                                    value="clean" <?= $disabledForm ? '' : ' disabled'; ?> >Удалить скрипт
                            </button>
                        </div>
                    </div>

                    <?php
                    if ($fixit->isFinishStage() && $fixit->isPreviewAction() && $findedFiles) { ?>
                        <div class="mt-3 card">
                            <div class="card-body">
                                <div class="mb-3 form-check">
                                    <input type="hidden" value="0"
                                           name="options[create_back]" <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <input type="checkbox" class="form-check-input" id="options--create_back"
                                           value="1"
                                           name="options[create_back]" <?= $options['create_back'] ? ' checked' : ''; ?> <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <label class="form-check-label" for="options--create_back">Создать .back для
                                        измененных файлов</label>
                                </div>

                                <div class="mb-3 form-check">
                                    <input type="hidden" value="0"
                                           name="options[create_zip]" <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <input type="checkbox" class="form-check-input" id="options--create_zip"
                                           value="1"
                                           name="options[create_zip]" <?= $options['create_zip'] ? ' checked' : ''; ?> <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <label class="form-check-label" for="options--create_zip">Создать .zip архив
                                        измененных файлов</label>
                                </div>

                                <div class="mb-3 form-check">
                                    <input type="hidden" value="0"
                                           name="options[self_deletion]" <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <input type="checkbox" class="form-check-input" id="options--self_deletion"
                                           value="1"
                                           name="options[self_deletion]" <?= $options['self_deletion'] ? ' checked' : ''; ?> <?= $disabledForm ? '' : ' disabled'; ?> />
                                    <label class="form-check-label" for="options--self_deletion">Удалить скрипт
                                        после выполнения</label>
                                </div>

                                <button type="button" class="btn btn-primary me-md-2" name="fix-button"
                                    <?= $disabledForm ? '' : ' disabled'; ?> onclick="fixItems()">Исправить выбранные
                                </button>
                            </div>
                        </div>
                        <?php
                    } ?>
                    <br>
                    <?php
                } ?>
                <?php
            } else { ?>
                <div class="alert alert-warning" role="alert">
                    Скрипт удален!
                </div>
                <?php
            } ?>

            <?php
            if (!$fixit->isMainAction()) { ?>
                <div>
                    <?php
                    if ($fixit->isFinishStage()) { ?>
                        <div class="alert alert-success" role="alert">
                            <?= $fixit->isPreviewAction() ? 'Сканирование ' : 'Исправление '; ?> завершено!
                        </div>
                        <?php
                    } else { ?>
                        <div class="alert alert-primary" role="alert">
                            <div class="spinner-border spinner-border-sm" role="status"></div>
                            Выполняется <?= $fixit->isPreviewAction() ? 'сканирование' : 'исправление'; ?>
                        </div>
                        <?= $fixit->nextStep(); ?>
                        <?php
                    } ?>

                    <div>Проверено файлов: <b><?= $cntCheckedFiles; ?></b></div>
                    <div>Потенциально небезопасных файлов: <b><?= count($findedFiles); ?></b></div>
                    <?php
                    if ($fixit->isFixAction()) { ?>
                        <div>Исправлено файлов: <b><?= count($fixedFiles); ?></b></div>
                        <?php
                    } ?>

                    <?php
                    if (
                        $fixit->isFixAction()
                        && $fixit->isFinishStage()
                        && $fixedFiles
                        && $options['create_zip']
                        && ($zipPath = str_replace($fixit->getSiteRoot(), '', $fixit->getZipPath()))
                    ) { ?>
                        <div>Создан .zip архив: <b><a href="<?= $zipPath; ?>"
                                                      target="_blank"><?= $zipPath; ?></a></b></div>
                        <?php
                    } ?>
                </div>
                <?php
            } ?>

            <div class="mt-3">
                <?php
                if ($fixit->isFinishStage() && (($fixit->isPreviewAction() && $findedFiles) || ($fixit->isFixAction() && $fixedFiles))) { ?>
                    <div class="mt-3">
                        <?php
                        if ($fixit->isFixAction()) { ?>
                            <?php
                            foreach ($fixedFiles as $fixedFile => $type) { ?>
                                <div class="mb-3 form-check">
                                    <?php
                                    $path = str_replace($fixit->getSiteRoot(), '', $fixedFile);
                                    ?>
                                    <label class="form-check-label"><?= $path ?>
                                        &nbsp;&nbsp;
                                        <a href="/bitrix/admin/fileman_file_view.php?path=<?= urlencode($path) ?>&site=<?= $siteId ?>&lang=ru"
                                           target="_blank">посмотреть файл</a>
                                    </label>
                                </div>
                                <?php
                            } ?>
                            <?php
                        } else { ?>
                            <div class="mb-3">
                                <span id="select_all" class="btn btn-secondary btn-sm">Выбрать все</span>
                                <span id="unselect_all" class="btn btn-secondary btn-sm"
                                      style="display:none;">Снять все</span>
                                <script>
                                    function fixItems() {
                                        const form = document.getElementsByTagName('form')[0];
                                        const items = form.querySelectorAll('[name="options[files][]"]');
                                        if (!items) {
                                            return;
                                        }

                                        const enabled = Array.from(items).some(checkbox => checkbox.checked)
                                        if (!enabled) {
                                            alert('Выберите элементы для исправления!');
                                            return;
                                        }

                                        const inputFix = document.createElement('input');
                                        inputFix.type = 'hidden';
                                        inputFix.name = 'action';
                                        inputFix.value = 'fix';

                                        form.appendChild(inputFix);
                                        form.submit()
                                    }

                                    (function () {
                                        document.querySelector('#select_all').addEventListener('click', function (e) {
                                            const target = e.target;

                                            if (target) {
                                                target.style.display = 'none';
                                                document.querySelector('#unselect_all').style.display = 'inline-block';

                                                target.closest('form').querySelectorAll('[name="options[files][]"]').forEach((checkbox) => {
                                                    checkbox.checked = true;
                                                });
                                            }
                                        });

                                        document.querySelector('#unselect_all').addEventListener('click', function (e) {
                                            const target = e.target;

                                            if (target) {
                                                target.style.display = 'none';
                                                document.querySelector('#select_all').style.display = 'inline-block';

                                                target.closest('form').querySelectorAll('[name="options[files][]"]').forEach((checkbox) => {
                                                    checkbox.checked = false;
                                                });
                                            }
                                        });
                                    })();
                                </script>
                            </div>

                            <?php
                            foreach (array_keys($findedFiles) as $i => $findedFile) { ?>
                                <div class="mb-3 form-check">
                                <input type="checkbox" class="form-check-input" id="options--files[<?= $i ?>]"
                                       value="<?= $findedFile ?>" name="options[files][]"/>
                                <?php
                                $path = str_replace($fixit->getSiteRoot(), '', $findedFile);
                                ?>
                                <label class="form-check-label" for="options--files[<?= $i; ?>]"><?= $path ?>
                                    &nbsp;&nbsp
                                    <a href="/bitrix/admin/fileman_file_view.php?path=<?= urlencode($path) ?>&site=<?= $siteId ?>&lang=ru"
                                       target="_blank">посмотреть файл</a>
                                </label>
                                </div><?php
                            }
                        } ?>
                    </div>
                    <?php
                } ?>
            </div>
        </form>
    </div>
</div>
</body>
</html>
